
from azee.values import AZeeError

local_db_entries = {}  # local bindings: ref name -> expr

def local_db_deref(key):
    try:
        return local_db_entries[key]
    except KeyError:
        raise AZeeError('Unbound reference: %s' % key)

def known_ref(key):
    return key in local_db_entries

def listLocalEntries():
    return list(local_db_entries)

def addLocalEntry(key, expression):
    if key in local_db_entries:
        AZeeError('Overriding binding: %s' % key, src=expression.srcPos()).stderrWarning(AZeeError.BINDING)
    if expression.typeSpec().acceptsAll():
        AZeeError('Expression for binding "%s" has unidentified type.' % key, src=expression.srcPos()).stderrWarning(AZeeError.BINDING)
    local_db_entries[key] = expression
