# -*- coding: utf-8 -*-

strong_side = True

# SKELETON BONES
# dict values are parent bones for the keys (None for root)
bone_table = {
    'thumb_L_1': 'palm_L',
    'thumb_L_2': 'thumb_L_1',
    'thumb_L_3': 'thumb_L_2',
    'thumb_R_1': 'palm_R',
    'thumb_R_2': 'thumb_R_1',
    'thumb_R_3': 'thumb_R_2',
    
    'index_L_1': 'palm_L',
    'index_L_2': 'index_L_1',
    'index_L_3': 'index_L_2',
    'index_R_1': 'palm_R',
    'index_R_2': 'index_R_1',
    'index_R_3': 'index_R_2',
    
    'middle_L_1': 'palm_L',
    'middle_L_2': 'middle_L_1',
    'middle_L_3': 'middle_L_2',
    'middle_R_1': 'palm_R',
    'middle_R_2': 'middle_R_1',
    'middle_R_3': 'middle_R_2',
    
    'ring_L_1': 'palm_L',
    'ring_L_2': 'ring_L_1',
    'ring_L_3': 'ring_L_2',
    'ring_R_1': 'palm_R',
    'ring_R_2': 'ring_R_1',
    'ring_R_3': 'ring_R_2',
    
    'little_L_1': 'palm_L',
    'little_L_2': 'little_L_1',
    'little_L_3': 'little_L_2',
    'little_R_1': 'palm_R',
    'little_R_2': 'little_R_1',
    'little_R_3': 'little_R_2',
    
    'clav_L': 'back_2',
    'clav_R': 'back_2',
    
    'arm_L': 'clav_L',
    'arm_R': 'clav_R',
    
    'f_arm_L': 'arm_L',
    'f_arm_R': 'arm_R',
    
    'palm_L': 'f_arm_L',
    'palm_R': 'f_arm_R',
    
    'neck': 'back_2',
    'eye_L': 'head',
    'eye_R': 'head',
    'head': 'neck',

    'back_2': 'back_1',
    'back_1': None
}

# MORPH ACTIONS
morph_table = [
    # finger morphs
    'index_bend_L', 'middle_bend_L', 'ring_bend_L', 'little_bend_L',
    'index_bend_R', 'middle_bend_R', 'ring_bend_R', 'little_bend_R',
    'index_hook_L', 'middle_hook_L', 'ring_hook_L', 'little_hook_L',
    'index_hook_R', 'middle_hook_R', 'ring_hook_R', 'little_hook_R',
    'thumb_bend_L', 'thumb_hook_L', 'thumb_opposed_L',
    'thumb_bend_R', 'thumb_hook_R', 'thumb_opposed_R',
    'fingers_spread_L', 'fingers_spread_R',

    # body posture morphs
    #'f_arm_closed_L', 'f_arm_closed_R',
    'shoulder_raise_L', 'shoulder_raise_R',
    'shoulder_shrug_L', 'shoulder_shrug_R',
    'spine_extended',

    # face morphs
    'AU1', #  Inner Brow Raise
    'AU1_a', #  Inner Brow Raise (Alternative)
    'AU1_L', #  Inner Brow Raise (Left)
    'AU1_R', #  Inner Brow Raise (Right)
    'AU2', #  Outer Brow Raise
    'AU2_a', #  Outer Brow Raise (Alternative)
    'AU2_L', #  Outer Brow Raise (Left)
    'AU2_R', #  Outer Brow Raise (Right)
    'AU4', #  Brow Lowerer
    'AU4_a', #  Brow Lowerer (Alternative A)
    'AU4_b', #  Brow Lowerer (Alternative B)
    'AU5', #  Upper Lid Raise
    'AU5_L', #  Upper Lid Raise (Left)
    'AU5_R', #  Upper Lid Raise (Right)
    'AU6', #  Cheek Raise
    'AU6_a', #  Cheek Raise (Alternative A)
    'AU6_b', #  Cheek Raise (Alternative B)
    'AU6_L', #  Cheek Raise (Left)
    'AU6_R', #  Cheek Raise (Right)
    'AU7', #  Lids Tight
    'AU7_L', #  Lids Tight (Left)
    'AU7_R', #  Lids Tight (Right)
    'AU8', #  Lips Toward Each Other
    'AU9', #  Nose Wrinkle
    'AU9_a', #  Nose Wrinkle (Alternative A)
    'AU9_L', #  Nose Wrinkle (Left)
    'AU9_R', #  Nose Wrinkle (Right)
    'AU10', # Upper Lip Raiser
    'AU10_L', # Upper Lip Raiser (Left)
    'AU10_R', # Upper Lip Raiser (Right)
    'AU11', # Nasolabial Furrow Deepener
    'AU11_L', # Nasolabial Furrow Deepener (Left)
    'AU11_R', # Nasolabial Furrow Deepener (Right)
    'AU12', # Lip Corner Puller
    'AU12_a', # Lip Corner Puller (Alternative A)
    'AU12_b', # Lip Corner Puller (Alternative B)
    'AU12_L', # Lip Corner Puller (Left)
    'AU12_R', # Lip Corner Puller (Right)
    'AU13', # Sharp Lip Puller
    'AU13_L', # Sharp Lip Puller (Left)
    'AU13_R', # Sharp Lip Puller (Right)
    'AU14', # Dimpler
    'AU14_R', # Dimpler (Right)
    'AU14_L', # Dimpler (Left)
    'AU15', # Lip Corner Depressor
    'AU15_L', # Lip Corner Depressor (Left)
    'AU15_R', # Lip Corner Depressor (Right)
    'AU16', # Lower Lip Depress
    'AU17', # Chin Raiser
    'AU17_a', # Chin Raiser (Alternative A)
    'AU18', # Lip Pucker
    'AU18_a', # Lip Pucker (Alternative)',
    'AU19', # Tongue Show
    'AU20', # Lip Stretch
    'AU20_L', # Lip Stretch (Left) (Alternative)
    'AU20_R', # Lip Stretch (Right) (Alternative)
    'AU21', # Neck Tightener',
    'AU22_25_down', # Lip Funneler (Bottom Lip)
    'AU22_25_up_down', # Lip Funneler (Both Lip)
    'AU22_25_upper', # Lip Funneler (Upper Lip)
    'AU23', # Lip Tightener
    'AU24', # Lip Presser
    'AU25', # Lips Part
    'AU25_L', # Lips Part (Left)
    'AU25_R', # Lips Part (Right)
    'AU25_a', # Lips Part (Alternative A)
    'AU26', # Jaw Drop
    'AU26_lip_down', # Jaw Drop Bottom Lip Down (Alternative)
    'AU26_tongue_down', # Jaw Drop Tongue Down (Alternative)
    'AU26_tongue_out', # Jaw Drop Tongue Out (Alternative)
    'AU26_a', # Jaw Drop (Alternative)
    'AU27', # Mouth Stretch',
    'AU28', # Lips Suck
    'AU28_a', # Lips Suck (Upper lip)
    'AU28_bottom', # Lips Suck (Lower lip)
    'AU29', # Jaw Thrust
    'AU30_L', # Jaw Sideways (Left)
    'AU30_R', # Jaw Sideways (Right)
    'AU31', # Jaw Clencher
    'AU32', # Bite
    'AU33', # Blow',
    'AU34', # Puff',
    'AU35', # Cheek Suck',
    'AU36', # Tongue Bulge',
    'AU37', # Lip Wipe',
    'AU38', # Nostril Dilate
    'AU39', # Nostril Compress
    'AU43', # Eye Closure
    'AU43_L', # for 45 Blink, 46 Wink (Left)
    'AU43_R', # for 45 Blink, 46 Wink (Right),

    'tongue_back_up', 'tongue_out', 'tongue_up', 'tongue_wide' # TODO additional morphs for tongue from FaceShift
]

# BODY SITES
# dict values are linked bones for the keys
site_table = {
    'AB': 'back_1',
    'AB_L': 'back_1',
    'AB_R': 'back_1',
    'ABST_L': 'back_1',
    'ABST_R': 'back_1',
    'ABST': 'back_1',
    'ARM_L': 'arm_L',
    'ARMpit_L': 'back_2',
    'ARMpit_R': 'back_2',
    'ARM_R': 'arm_R',
    'ARMsh_L': 'arm_L',
    'ARMsh_R': 'arm_R',
    'BEB': 'head',
    'CB_L': 'head',
    'CB_R': 'head',
    'CDL_L': 'head',
    'CDL_R': 'head',
    'CH': 'head',
    'CH_L': 'head',
    'CH_R': 'head',
    'CK_L': 'head',
    'CK_R': 'head',
    'EAR_L': 'head',
    'EAR_R': 'head',
    'EBe_L': 'head',
    'EBe_R': 'head',
    'EBi_L': 'head',
    'EBi_R': 'head',
    'EB_L': 'head',
    'EB_R': 'head',
    'ELi_L': 'arm_L',
    'ELi_R': 'arm_R',
    'EL_L': 'arm_L',
    'EL_R': 'arm_R',
    'EYE_L': 'head',
    'EYE_R': 'head',
    'F_ARMi_L': 'f_arm_L',
    'F_ARMi_R': 'f_arm_R',
    'F_ARM_L': 'f_arm_L',
    'F_ARM_R': 'f_arm_R',
    'FH': 'head',
    'FH_L': 'head',
    'FH_R': 'head',
    'H_BACK_L': 'palm_L',
    'H_BACK_R': 'palm_R',
    'HEAD': 'head',
    'HEAD_L': 'head',
    'HEAD_R': 'head',
    'H_EDGE_L': 'palm_L',
    'H_EDGE_R': 'palm_R',
    'I_BACK_L_1': 'index_L_1',
    'I_BACK_R_1': 'index_R_1',
    'I_BACK_L_2': 'index_L_2',
    'I_BACK_R_2': 'index_R_2',
    'I_INT_L_1': 'index_L_1',
    'I_INT_R_1': 'index_R_1',
    'I_INT_L_2': 'index_L_2',
    'I_INT_R_2': 'index_R_2',
    'I_KN_L_1': 'index_L_1',
    'I_KN_R_1': 'index_R_1',
    'I_KN_L_2': 'index_L_2',
    'I_KN_R_2': 'index_R_2',
    'I_KN_L_3': 'index_L_3',
    'I_KN_R_3': 'index_R_3',
    'I_KNi_L_1': 'index_L_1',
    'I_KNi_R_1': 'index_R_1',
    'I_KNi_L_2': 'index_L_2',
    'I_KNi_R_2': 'index_R_2',
    'I_KNi_L_3': 'index_L_3',
    'I_KNi_R_3': 'index_R_3',
    'I_KNl_L_1': 'index_L_1',
    'I_KNl_R_1': 'index_R_1',
    'I_KNl_L_2': 'index_L_2',
    'I_KNl_R_2': 'index_R_2',
    'I_KNl_L_3': 'index_L_3',
    'I_KNl_R_3': 'index_R_3',
    'I_KNt_L_1': 'index_L_1',
    'I_KNt_R_1': 'index_R_1',
    'I_KNt_L_2': 'index_L_2',
    'I_KNt_R_2': 'index_R_2',
    'I_KNt_L_3': 'index_L_3',
    'I_KNt_R_3': 'index_R_3',
    'I_l_L_1': 'index_L_1',
    'I_l_R_1': 'index_R_1',
    'I_l_L_2': 'index_L_2',
    'I_l_R_2': 'index_R_2',
    'I_l_L_3': 'index_L_3',
    'I_l_R_3': 'index_R_3',
    'I_NA_L': 'index_L_3',
    'I_NA_R': 'index_R_3',
    'I_PAD_L': 'index_L_3',
    'I_PAD_R': 'index_R_3',
    'I_t_L_1': 'index_L_1',
    'I_t_R_1': 'index_R_1',
    'I_t_L_2': 'index_L_2',
    'I_t_R_2': 'index_R_2',
    'I_t_L_3': 'index_L_3',
    'I_t_R_3': 'index_R_3',
    'I_TIP_L': 'index_L_3',
    'I_TIP_R': 'index_R_3',
    'L_BACK_L_1': 'little_L_1',
    'L_BACK_R_1': 'little_R_1',
    'L_BACK_L_2': 'little_L_2',
    'L_BACK_R_2': 'little_R_2',
    'L_INT_L_1': 'little_L_1',
    'L_INT_R_1': 'little_R_1',
    'L_INT_L_2': 'little_L_2',
    'L_INT_R_2': 'little_R_2',
    'L_KN_L_1': 'little_L_1',
    'L_KN_R_1': 'little_R_1',
    'L_KN_L_2': 'little_L_2',
    'L_KN_R_2': 'little_R_2',
    'L_KN_L_3': 'little_L_3',
    'L_KN_R_3': 'little_R_3',
    'L_KNi_L_1': 'little_L_1',
    'L_KNi_R_1': 'little_R_1',
    'L_KNi_L_2': 'little_L_2',
    'L_KNi_R_2': 'little_R_2',
    'L_KNi_L_3': 'little_L_3',
    'L_KNi_R_3': 'little_R_3',
    'L_KNl_L_1': 'little_L_1',
    'L_KNl_R_1': 'little_R_1',
    'L_KNl_L_2': 'little_L_2',
    'L_KNl_R_2': 'little_R_2',
    'L_KNl_L_3': 'little_L_3',
    'L_KNl_R_3': 'little_R_3',
    'L_KNt_L_1': 'little_L_1',
    'L_KNt_R_1': 'little_R_1',
    'L_KNt_L_2': 'little_L_2',
    'L_KNt_R_2': 'little_R_2',
    'L_KNt_L_3': 'little_L_3',
    'L_KNt_R_3': 'little_R_3',
    'L_l_L_1': 'little_L_1',
    'L_l_R_1': 'little_R_1',
    'L_l_L_2': 'little_L_2',
    'L_l_R_2': 'little_R_2',
    'L_l_L_3': 'little_L_3',
    'L_l_R_3': 'little_R_3',
    'L_NA_L': 'little_L_3',
    'L_NA_R': 'little_R_3',
    'LOBE_L': 'head',
    'LOBE_R': 'head',
    'L_PAD_L': 'little_L_3',
    'L_PAD_R': 'little_R_3',
    'L_t_L_1': 'little_L_1',
    'L_t_R_1': 'little_R_1',
    'L_t_L_2': 'little_L_2',
    'L_t_R_2': 'little_R_2',
    'L_t_L_3': 'little_L_3',
    'L_t_R_3': 'little_R_3',
    'L_TIP_L': 'little_L_3',
    'L_TIP_R': 'little_R_3',
    'M_BACK_L_1': 'middle_L_1',
    'M_BACK_R_1': 'middle_R_1',
    'M_BACK_L_2': 'middle_L_2',
    'M_BACK_R_2': 'middle_R_2',
    'M_INT_L_1': 'middle_L_1',
    'M_INT_R_1': 'middle_R_1',
    'M_INT_L_2': 'middle_L_2',
    'M_INT_R_2': 'middle_R_2',
    'M_KN_L_1': 'middle_L_1',
    'M_KN_R_1': 'middle_R_1',
    'M_KN_L_2': 'middle_L_2',
    'M_KN_R_2': 'middle_R_2',
    'M_KN_L_3': 'middle_L_3',
    'M_KN_R_3': 'middle_R_3',
    'M_KNi_L_1': 'middle_L_1',
    'M_KNi_R_1': 'middle_R_1',
    'M_KNi_L_2': 'middle_L_2',
    'M_KNi_R_2': 'middle_R_2',
    'M_KNi_L_3': 'middle_L_3',
    'M_KNi_R_3': 'middle_R_3',
    'M_KNl_L_1': 'middle_L_1',
    'M_KNl_R_1': 'middle_R_1',
    'M_KNl_L_2': 'middle_L_2',
    'M_KNl_R_2': 'middle_R_2',
    'M_KNl_L_3': 'middle_L_3',
    'M_KNl_R_3': 'middle_R_3',
    'M_KNt_L_1': 'middle_L_1',
    'M_KNt_R_1': 'middle_R_1',
    'M_KNt_L_2': 'middle_L_2',
    'M_KNt_R_2': 'middle_R_2',
    'M_KNt_L_3': 'middle_L_3',
    'M_KNt_R_3': 'middle_R_3',
    'M_l_L_1': 'middle_L_1',
    'M_l_R_1': 'middle_R_1',
    'M_l_L_2': 'middle_L_2',
    'M_l_R_2': 'middle_R_2',
    'M_l_L_3': 'middle_L_3',
    'M_l_R_3': 'middle_R_3',
    'M_NA_L': 'middle_L_3',
    'M_NA_R': 'middle_R_3',
    'MO': 'head',
    'MO_L': 'head',
    'MO_R': 'head',
    'M_PAD_L': 'middle_L_3',
    'M_PAD_R': 'middle_R_3',
    'M_t_L_1': 'middle_L_1',
    'M_t_R_1': 'middle_R_1',
    'M_t_L_2': 'middle_L_2',
    'M_t_R_2': 'middle_R_2',
    'M_t_L_3': 'middle_L_3',
    'M_t_R_3': 'middle_R_3',
    'M_TIP_L': 'middle_L_3',
    'M_TIP_R': 'middle_R_3',
    'NK_L': 'neck',
    'NK': 'neck',
    'NK_R': 'neck',
    'NO': 'head',
    'NO_L': 'head',
    'NO_R': 'head',
    'NSP': 'head',
    'PA_L': 'palm_L',
    'PA_R': 'palm_R',
    'R_BACK_L_1': 'ring_L_1',
    'R_BACK_R_1': 'ring_R_1',
    'R_BACK_L_2': 'ring_L_2',
    'R_BACK_R_2': 'ring_R_2',
    'R_INT_L_1': 'ring_L_1',
    'R_INT_R_1': 'ring_R_1',
    'R_INT_L_2': 'ring_L_2',
    'R_INT_R_2': 'ring_R_2',
    'R_KN_L_1': 'ring_L_1',
    'R_KN_R_1': 'ring_R_1',
    'R_KN_L_2': 'ring_L_2',
    'R_KN_R_2': 'ring_R_2',
    'R_KN_L_3': 'ring_L_3',
    'R_KN_R_3': 'ring_R_3',
    'R_KNi_L_1': 'ring_L_1',
    'R_KNi_R_1': 'ring_R_1',
    'R_KNi_L_2': 'ring_L_2',
    'R_KNi_R_2': 'ring_R_2',
    'R_KNi_L_3': 'ring_L_3',
    'R_KNi_R_3': 'ring_R_3',
    'R_KNl_L_1': 'ring_L_1',
    'R_KNl_R_1': 'ring_R_1',
    'R_KNl_L_2': 'ring_L_2',
    'R_KNl_R_2': 'ring_R_2',
    'R_KNl_L_3': 'ring_L_3',
    'R_KNl_R_3': 'ring_R_3',
    'R_KNt_L_1': 'ring_L_1',
    'R_KNt_R_1': 'ring_R_1',
    'R_KNt_L_2': 'ring_L_2',
    'R_KNt_R_2': 'ring_R_2',
    'R_KNt_L_3': 'ring_L_3',
    'R_KNt_R_3': 'ring_R_3',
    'R_l_L_1': 'ring_L_1',
    'R_l_R_1': 'ring_R_1',
    'R_l_L_2': 'ring_L_2',
    'R_l_R_2': 'ring_R_2',
    'R_l_L_3': 'ring_L_3',
    'R_l_R_3': 'ring_R_3',
    'R_NA_L': 'ring_L_3',
    'R_NA_R': 'ring_R_3',
    'R_PAD_L': 'ring_L_3',
    'R_PAD_R': 'ring_R_3',
    'R_t_L_1': 'ring_L_1',
    'R_t_R_1': 'ring_R_1',
    'R_t_L_2': 'ring_L_2',
    'R_t_R_2': 'ring_R_2',
    'R_t_L_3': 'ring_L_3',
    'R_t_R_3': 'ring_R_3',
    'R_TIP_L': 'ring_L_3',
    'R_TIP_R': 'ring_R_3',
    'SH_L': 'arm_L',
    'SH_R': 'arm_R',
    'ST_L': 'back_2',
    'ST_R': 'back_2',
    'ST': 'back_2',
    'T_BACK_L_1': 'thumb_L_1',
    'T_BACK_R_1': 'thumb_R_1',
    'T_BACK_L_2': 'thumb_L_2',
    'T_BACK_R_2': 'thumb_R_2',
    'TE_L': 'head',
    'TE_R': 'head',
    'T_INT_L_1': 'thumb_L_1',
    'T_INT_R_1': 'thumb_R_1',
    'T_INT_L_2': 'thumb_L_2',
    'T_INT_R_2': 'thumb_R_2',
    'T_KN_L_1': 'thumb_L_1',
    'T_KN_R_1': 'thumb_R_1',
    'T_KN_L_2': 'thumb_L_2',
    'T_KN_R_2': 'thumb_R_2',
    'T_KN_L_3': 'thumb_L_3',
    'T_KN_R_3': 'thumb_R_3',
    'T_KNi_L_1': 'thumb_L_1',
    'T_KNi_R_1': 'thumb_R_1',
    'T_KNi_L_2': 'thumb_L_2',
    'T_KNi_R_2': 'thumb_R_2',
    'T_KNi_L_3': 'thumb_L_3',
    'T_KNi_R_3': 'thumb_R_3',
    'T_KNl_L_1': 'thumb_L_1',
    'T_KNl_R_1': 'thumb_R_1',
    'T_KNl_L_2': 'thumb_L_2',
    'T_KNl_R_2': 'thumb_R_2',
    'T_KNl_L_3': 'thumb_L_3',
    'T_KNl_R_3': 'thumb_R_3',
    'T_KNt_L_1': 'thumb_L_1',
    'T_KNt_R_1': 'thumb_R_1',
    'T_KNt_L_2': 'thumb_L_2',
    'T_KNt_R_2': 'thumb_R_2',
    'T_KNt_L_3': 'thumb_L_3',
    'T_KNt_R_3': 'thumb_R_3',
    'T_l_L_1': 'thumb_L_1',
    'T_l_R_1': 'thumb_R_1',
    'T_l_L_2': 'thumb_L_2',
    'T_l_R_2': 'thumb_R_2',
    'T_l_L_3': 'thumb_L_3',
    'T_l_R_3': 'thumb_R_3',
    'T_NA_L': 'thumb_L_2',
    'T_NA_R': 'thumb_R_2',
    'TO': 'head',
    'T_PAD_L': 'thumb_L_2',
    'T_PAD_R': 'thumb_R_2',
    'T_t_L_1': 'thumb_L_1',
    'T_t_R_1': 'thumb_R_1',
    'T_t_L_2': 'thumb_L_2',
    'T_t_R_2': 'thumb_R_2',
    'T_t_L_3': 'thumb_L_3',
    'T_t_R_3': 'thumb_R_3',
    'T_TIP_L': 'thumb_L_3',
    'T_TIP_R': 'thumb_R_3',
    'viande_L': 'palm_L',
    'viande_R': 'palm_R',
    'WRi_L': 'palm_L',
    'WRi_R': 'palm_R',
    'WR_L': 'palm_L',
    'WRl_L': 'palm_L',
    'WRl_R': 'palm_R',
    'WR_R': 'palm_R',
    'WRt_L': 'palm_L',
    'WRt_R': 'palm_R'
}



def root_bone():
    return next(b for b, p in bone_table.items() if p is None)

def skel_bones():
    return list(bone_table)

def body_sites():
    return list(site_table)

def parent_bone(b):
    return bone_table[b]

def linked_bone(s):
    return site_table[s]

def is_ancestor(b1, b2) -> bool:
    return b1 == b2 or b2 != root_bone() and is_ancestor(b1, parent_bone(b2))

def DCA(bones):
    """
    Deepest common ancestor ("deep" means from root to leaf)
    """
    tree = {b: 0 for b in skel_bones()}
    for b in bones:
        cur = b
        while cur is not None:
            tree[cur] += 1
            cur = parent_bone(cur)
    # Returns the first higher counter block encountered when going deep to shallow
    b = bones[0]
    while tree[b] != len(bones):
        b = parent_bone(b)
    return b
