from sys import stderr

max_indent_lvl = None

trace_flags = []  # 'eval'
trace_indent = 0


def setDebugFlag(flag):
    """
    Add a channel to the debug trace printouts.
    Each call to 'trace' in the code will output in the stderr.

    :param flag: the string to add to the set of active debug channels
    :return: None
    """
    trace_flags.append(flag)


def resetDebugFlag(flag):
    global trace_flags
    trace_flags = [f for f in trace_flags if f != flag]


def trace(msg, channel=None):
    if (channel is None or channel in trace_flags) \
            and (max_indent_lvl is None or trace_indent <= max_indent_lvl):
        print('[DEBUG] %s%s' % (trace_indent * '.. ', msg), file=stderr)


def trace_begin(msg, channel=None):
    global trace_indent
    trace(msg, channel)
    trace_indent += 1


def trace_end(msg='done.', channel=None):
    global trace_indent
    trace_indent -= 1
    trace(msg, channel)
